﻿using MySqlInheritanceBug.Entities;
using System.Data.Entity.Migrations;

namespace MySqlInheritanceBug
{
    internal sealed class Configuration : DbMigrationsConfiguration<Context>
    {
        public Configuration()
        {
            AutomaticMigrationsEnabled = true;
            CodeGenerator = new MySql.Data.Entity.MySqlMigrationCodeGenerator();
            SetSqlGenerator("MySql.Data.MySqlClient", new MySql.Data.Entity.MySqlMigrationSqlGenerator());
        }

        protected override void Seed(Context context)
        {
            context.Dogs.AddOrUpdate(d => d.Name,
                new Dog { Name = "Max", AnimalProperty1 = "male dog", DogProperty1 = "Dog1" });
            context.HouseCats.AddOrUpdate(hc => hc.Name,
                new HouseCat { Name = "Sophie", AnimalProperty1 = "female cat", CatProperty1 = "Cat2", HouseCatProperty1 = "HouseCat2" });
            context.Cats.AddOrUpdate(c => c.Name,
                new Cat { Name = "Chloe", AnimalProperty1 = "female cat", CatProperty1 = "Cat3" });
            context.Animals.AddOrUpdate(a => a.Name,
                new Cat { Name = "Lucy", AnimalProperty1 = "female cat", CatProperty1 = "Cat4" },
                new Dog { Name = "Buddy", AnimalProperty1 = "male dog", DogProperty1 = "Dog5" });
            context.SaveChanges();
        }
    }
}
