﻿using MySqlInheritanceBug.Entities;
using System.Data.Entity;

namespace MySqlInheritanceBug
{
    public class Context : DbContext
    {
        public Context() : base("name=MySqlInheritanceBug")
        {
            Database.SetInitializer(new MigrateDatabaseToLatestVersion<Context,
                MySqlInheritanceBug.Configuration>("MySqlInheritanceBug"));
        }

        public virtual DbSet<Animal> Animals { get; set; }
        public virtual DbSet<Cat> Cats { get; set; }
        public virtual DbSet<HouseCat> HouseCats { get; set; }
        public virtual DbSet<Dog> Dogs { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            //TPT
            modelBuilder.Entity<Animal>().ToTable("Animal");
            modelBuilder.Entity<Cat>().ToTable("Cat");
            modelBuilder.Entity<HouseCat>().ToTable("HouseCat");
            modelBuilder.Entity<Dog>().ToTable("Dog");
        }
    }
}
