﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using MySqlInheritanceBug;
using MySqlInheritanceBug.Entities;
using System.Linq;

namespace Test
{
    [TestClass]
    public class AnimalTest
    {
        private Context context = null;

        [TestInitialize]
        public void TestInitialize()
        {
            context = new Context();
        }

        [TestCleanup]
        public void TestCleanup()
        {
            context = null;
        }

        public TestContext TestContext { get; set; }

        [TestMethod]
        public void AnimalTest1()
        {
            TestContext.WriteLine("AnimalTest1");

            foreach (Animal a in context.Animals)
            {
                TestContext.WriteLine("  Animal: " + a);
            }
            TestContext.WriteLine("");

            TestContext.WriteLine("-----------------------");
            TestContext.WriteLine("");

            TestContext.WriteLine("First animal: " + context.Animals.First());
            TestContext.WriteLine("");

            TestContext.WriteLine("First cat: " + context.Cats.First());
            TestContext.WriteLine("");

            TestContext.WriteLine("First dog: " + context.Dogs.First());
            TestContext.WriteLine("");

            TestContext.WriteLine("-----------------------");
            TestContext.WriteLine("");

            TestContext.WriteLine("First animal name B: " + context.Animals.First(a => a.Name.StartsWith("B")));
            TestContext.WriteLine("");

            TestContext.WriteLine("First animal name C: " + context.Animals.First(a => a.Name.StartsWith("C")));
            TestContext.WriteLine("");

            TestContext.WriteLine("First animal name L: " + context.Animals.First(a => a.Name.StartsWith("L")));
            TestContext.WriteLine("");

            TestContext.WriteLine("-----------------------");
            TestContext.WriteLine("");

            TestContext.WriteLine("First cat name S: " + context.Cats.First(a => a.Name.StartsWith("S")));
            TestContext.WriteLine("");

            //this will throw:
            TestContext.WriteLine("First cat name L: " + context.Cats.First(a => a.Name.StartsWith("L")));
            TestContext.WriteLine("");
        }
    }
}
